Index: trunk/NEMOGCM/NEMO/OPA_SRC/DTA/dtatem.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DTA/dtatem.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DTA/dtatem.F90	(revision 2528)
@@ -4,4 +4,10 @@
    !! Ocean data  :  read ocean temperature data from monthly atlas data
    !!=====================================================================
+   !! History :  OPA  ! 1991-03  ()  Original code
+   !!             -   ! 1992-07  (M. Imbard)
+   !!            8.0  ! 1999-10  (M.A. Foujols, M. Imbard)  NetCDF FORMAT 
+   !!   NEMO     1.0  ! 2002-06  (G. Madec)  F90: Free form and module 
+   !!            3.3  ! 2010-10  (C. Bricaud, S. Masson)  use of fldread
+   !!----------------------------------------------------------------------
 #if defined key_dtatem   ||   defined key_esopa
    !!----------------------------------------------------------------------
@@ -10,43 +16,28 @@
    !!   dta_tem      : read ocean temperature data
    !!---l-------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and tracers
    USE dom_oce         ! ocean space and time domain
+   USE fldread         ! read input fields
    USE in_out_manager  ! I/O manager
    USE phycst          ! physical constants
-#if defined key_orca_lev10
-   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-#endif
+
    IMPLICIT NONE
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC dta_tem   ! called by step.F90 and inidta.F90
-
-   !! * Shared module variables
+   PUBLIC   dta_tem    ! called by step.F90 and inidta.F90
+
    LOGICAL , PUBLIC, PARAMETER ::   lk_dtatem = .TRUE.   !: temperature data flag
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &  !:
-      t_dta             !: temperature data at given time-step
-
-   !! * Module variables
-   INTEGER ::   &
-      numtdt,        &  !: logical unit for data temperature
-      ntem1, ntem2  ! first and second record used
-   REAL(wp), DIMENSION(jpi,jpj,jpk,2) ::   &
-      temdta            ! temperature data at two consecutive times
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::  t_dta    !: temperature data at given time-step
+
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_tem      ! structure of input SST (file informations, fields read)
 
    !! * Substitutions
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
-
-   !!----------------------------------------------------------------------
-   !!   Default case                                            NetCDF file
-   !!----------------------------------------------------------------------
 
    SUBROUTINE dta_tem( kt )
@@ -66,258 +57,173 @@
       !!
       !! ** Action  :   define t_dta array at time-step kt
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT( in ) ::   kt     ! ocean time-step
+      !
+      INTEGER ::   ji, jj, jk, jl, jkk            ! dummy loop indicies
+      INTEGER ::   ik, ierror                     ! temporary integers
+#if defined key_tradmp
+      INTEGER ::   il0, il1, ii0, ii1, ij0, ij1   ! temporary integers
+#endif
+      REAL(wp)::   zl
+      REAL(wp), DIMENSION(jpk) ::   ztemdta            ! auxiliary array for interpolation
+      !
+      CHARACTER(len=100)       ::   cn_dir             ! Root directory for location of ssr files
+      TYPE(FLD_N)              ::   sn_tem
+      LOGICAL , SAVE           ::   linit_tem = .FALSE.
       !!
-      !! History :
-      !!        !  91-03  ()  Original code
-      !!        !  92-07  (M. Imbard)
-      !!        !  99-10  (M.A. Foujols, M. Imbard)  NetCDF FORMAT 
-      !!   8.5  !  02-09  (G. Madec)  F90: Free form and module
+      NAMELIST/namdta_tem/   cn_dir, sn_tem
       !!----------------------------------------------------------------------
-      !! * Modules used
-      USE iom
-
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt     ! ocean time-step
-
-      !! * Local declarations
-      INTEGER ::   ji, jj, jl, jk, jkk       ! dummy loop indicies
-      INTEGER ::   &
-         imois, iman, i15 , ik      ! temporary integers
-#  if defined key_tradmp
-      INTEGER ::   &
-         il0, il1, ii0, ii1, ij0, ij1   ! temporary integers
-# endif
-      REAL(wp) ::   zxy, zl
-#if defined key_orca_lev10
-      REAL(wp), DIMENSION(jpi,jpj,jpkdta,2) :: ztem
-      INTEGER   :: ikr, ikw, ikt, jjk 
-      REAL(wp)  :: zfac
-#endif
-      REAL(wp), DIMENSION(jpk,2) ::   &
-         ztemdta            ! auxiliary array for interpolation
-      !!----------------------------------------------------------------------
-      
-      ! 0. Initialization
-      ! -----------------
-      
-      iman  = INT( raamo )
-!!! better but change the results     i15 = INT( 2*FLOAT( nday ) / ( FLOAT( nobis(nmonth) ) + 0.5 ) )
-      i15   = nday / 16
-      imois = nmonth + i15 - 1
-      IF( imois == 0 ) imois = iman
-      
-      ! 1. First call kt=nit000
+ 
+      ! 1. Initialization 
       ! -----------------------
       
-      IF( kt == nit000 ) THEN
-         
-         ntem1= 0   ! initializations
-         IF(lwp) WRITE(numout,*) ' dta_tem : Levitus monthly fields'
-         CALL iom_open ( 'data_1m_potential_temperature_nomask', numtdt ) 
-         
-      ENDIF
-      
+      IF( kt == nit000 .AND. (.NOT. linit_tem ) ) THEN
+
+         !                   ! set file information
+         cn_dir = './'       ! directory in which the model is executed
+         ! ... default values (NB: frequency positive => hours, negative => months)
+         !            !   file    ! frequency ! variable  ! time intep !  clim   ! 'yearly' or ! weights  ! rotation !
+         !            !   name    !  (hours)  !  name     !   (T/F)    !  (T/F)  !  'monthly'  ! filename ! pairs    !
+         sn_tem = FLD_N( 'temperature',  -1.  , 'votemper',  .false.   , .true.  ,  'yearly'   , ''       , ''       )
+
+         REWIND( numnam )          ! read in namlist namdta_tem 
+         READ( numnam, namdta_tem ) 
+
+         IF(lwp) THEN              ! control print
+            WRITE(numout,*)
+            WRITE(numout,*) 'dta_tem : Temperature Climatology '
+            WRITE(numout,*) '~~~~~~~ '
+         ENDIF
+         ALLOCATE( sf_tem(1), STAT=ierror )
+         IF( ierror > 0 ) THEN
+             CALL ctl_stop( 'dta_tem: unable to allocate sf_tem structure' )   ;   RETURN
+         ENDIF
+                                ALLOCATE( sf_tem(1)%fnow(jpi,jpj,jpk)   )
+         IF( sn_tem%ln_tint )   ALLOCATE( sf_tem(1)%fdta(jpi,jpj,jpk,2) )
+         !                         ! fill sf_tem with sn_tem and control print
+         CALL fld_fill( sf_tem, (/ sn_tem /), cn_dir, 'dta_tem', 'Temperature data', 'namdta_tem' )
+         linit_tem = .TRUE.
+         !
+      ENDIF
       
       ! 2. Read monthly file
       ! -------------------
-      
-      IF( kt == nit000 .OR. imois /= ntem1 ) THEN
-         
-         ! Calendar computation
-         
-         ntem1 = imois        ! first file record used 
-         ntem2 = ntem1 + 1    ! last  file record used
-         ntem1 = MOD( ntem1, iman )
-         IF( ntem1 == 0 )   ntem1 = iman
-         ntem2 = MOD( ntem2, iman )
-         IF( ntem2 == 0 )   ntem2 = iman
-         IF(lwp) WRITE(numout,*) 'first record file used ntem1 ', ntem1
-         IF(lwp) WRITE(numout,*) 'last  record file used ntem2 ', ntem2
-         
-         ! Read monthly temperature data Levitus 
-         
-#if defined key_orca_lev10
-         if (ln_zps) stop
-         ztem(:,:,:,:) = 0.
-         CALL iom_get (numtdt,jpdom_data,'votemper',ztem(:,:,:,1),ntem1)
-         CALL iom_get (numtdt,jpdom_data,'votemper',ztem(:,:,:,2),ntem2)
-#else         
-         CALL iom_get (numtdt,jpdom_data,'votemper',temdta(:,:,:,1),ntem1)
-         CALL iom_get (numtdt,jpdom_data,'votemper',temdta(:,:,:,2),ntem2)
+         
+      CALL fld_read( kt, 1, sf_tem )
+       
+      IF( lwp .AND. kt == nit000 )THEN 
+         WRITE(numout,*)
+         WRITE(numout,*) ' read Levitus temperature ok'
+         WRITE(numout,*)
+      ENDIF
+         
+#if defined key_tradmp
+      IF( cp_cfg == "orca" .AND. jp_cfg == 2 ) THEN      !  ORCA_R2 configuration
+         !
+         ij0 = 101   ;   ij1 = 109
+         ii0 = 141   ;   ii1 = 155
+         DO jj = mj0(ij0), mj1(ij1)                      ! Reduced temperature in the Alboran Sea
+            DO ji = mi0(ii0), mi1(ii1)
+               sf_tem(1)%fnow(ji,jj, 13:13 ) = sf_tem(1)%fnow(ji,jj, 13:13 ) - 0.20
+               sf_tem(1)%fnow(ji,jj, 14:15 ) = sf_tem(1)%fnow(ji,jj, 14:15 ) - 0.35  
+               sf_tem(1)%fnow(ji,jj, 16:25 ) = sf_tem(1)%fnow(ji,jj, 16:25 ) - 0.40
+            END DO
+         END DO
+         !
+         IF( nn_cla == 1 ) THEN 
+            !                                         ! New temperature profile at Gibraltar
+            il0 = 138   ;   il1 = 138
+            ij0 = 101   ;   ij1 = 102
+            ii0 = 139   ;   ii1 = 139
+            DO jl = mi0(il0), mi1(il1)
+               DO jj = mj0(ij0), mj1(ij1)
+                  DO ji = mi0(ii0), mi1(ii1)
+                     sf_tem(1)%fnow(ji,jj,:) = sf_tem(1)%fnow(jl,jj,:)
+                  END DO
+               END DO
+            END DO
+            !                                         ! New temperature profile at Bab el Mandeb
+            il0 = 164   ;   il1 = 164
+            ij0 =  87   ;   ij1 =  88
+            ii0 = 161   ;   ii1 = 163
+            DO jl = mi0(il0), mi1(il1)
+               DO jj = mj0(ij0), mj1(ij1)
+                  DO ji = mi0(ii0), mi1(ii1)
+                     sf_tem(1)%fnow(ji,jj,:) = sf_tem(1)%fnow(jl,jj,:)
+                  END DO
+               END DO
+            END DO
+         ELSE
+            !                                         ! Reduced temperature at Red Sea
+            ij0 =  87   ;   ij1 =  96
+            ii0 = 148   ;   ii1 = 160
+            sf_tem(1)%fnow( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ,  4:10 ) = 7.0
+            sf_tem(1)%fnow( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , 11:13 ) = 6.5
+            sf_tem(1)%fnow( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , 14:20 ) = 6.0
+         ENDIF
+            !
+      ENDIF
 #endif
          
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) ' read Levitus temperature ok'
-         IF(lwp) WRITE(numout,*)
-         
-#if defined key_tradmp
-         IF( cp_cfg == "orca"  .AND. jp_cfg == 2 ) THEN
+      t_dta(:,:,:) = sf_tem(1)%fnow(:,:,:) 
+         
+      IF( ln_sco ) THEN
+         DO jj = 1, jpj                  ! interpolation of temperatures
+            DO ji = 1, jpi
+               DO jk = 1, jpk
+                  zl=fsdept_0(ji,jj,jk)
+                  IF(zl < gdept_0(1))   ztemdta(jk) =  t_dta(ji,jj,1)
+                  IF(zl > gdept_0(jpk)) ztemdta(jk) =  t_dta(ji,jj,jpkm1) 
+                  DO jkk = 1, jpkm1
+                     IF((zl-gdept_0(jkk))*(zl-gdept_0(jkk+1)).le.0.0) THEN
+                        ztemdta(jk) = t_dta(ji,jj,jkk)                                 &
+                                  &    + (zl-gdept_0(jkk))/(gdept_0(jkk+1)-gdept_0(jkk))  &
+                                  &    * (t_dta(ji,jj,jkk+1) - t_dta(ji,jj,jkk))
+                     ENDIF
+                  END DO
+               END DO
+               DO jk = 1, jpkm1
+                  t_dta(ji,jj,jk) = ztemdta(jk)
+               END DO
+               t_dta(ji,jj,jpk) = 0.0
+            END DO
+         END DO
             
-            !                                        ! =======================
-            !                                        !  ORCA_R2 configuration
-            !                                        ! ======================= 
-            ij0 = 101   ;   ij1 = 109
-            ii0 = 141   ;   ii1 = 155
-            DO jj = mj0(ij0), mj1(ij1)                      ! Reduced temperature in the Alboran Sea
-               DO ji = mi0(ii0), mi1(ii1)
-#if defined key_orca_lev10
-                  ztem(  ji,jj, 13:13 ,:) = ztem  (ji,jj, 13:13 ,:) - 0.20
-                  ztem  (ji,jj, 14:15 ,:) = ztem  (ji,jj, 14:15 ,:) - 0.35
-                  ztem  (ji,jj, 16:25 ,:) = ztem  (ji,jj, 16:25 ,:) - 0.40
-#else
-                  temdta(ji,jj, 13:13 ,:) = temdta(ji,jj, 13:13 ,:) - 0.20
-                  temdta(ji,jj, 14:15 ,:) = temdta(ji,jj, 14:15 ,:) - 0.35
-                  temdta(ji,jj, 16:25 ,:) = temdta(ji,jj, 16:25 ,:) - 0.40
-#endif
-               END DO
-            END DO
+         IF( lwp .AND. kt == nit000 )THEN
+            WRITE(numout,*)
+            WRITE(numout,*) ' Levitus temperature data interpolated to s-coordinate'
+            WRITE(numout,*)
+         ENDIF
             
-            IF( n_cla == 1 ) THEN 
-               !                                         ! New temperature profile at Gibraltar
-               il0 = 138   ;   il1 = 138
-               ij0 = 101   ;   ij1 = 102
-               ii0 = 139   ;   ii1 = 139
-               DO jl = mi0(il0), mi1(il1)
-                  DO jj = mj0(ij0), mj1(ij1)
-                     DO ji = mi0(ii0), mi1(ii1)
-#if defined key_orca_lev10
-                        ztem  (ji,jj,:,:) = ztem  (jl,jj,:,:)
-#else
-                        temdta(ji,jj,:,:) = temdta(jl,jj,:,:)
-#endif
-                     END DO
-                  END DO
-               END DO
-               !                                         ! New temperature profile at Bab el Mandeb
-               il0 = 164   ;   il1 = 164
-               ij0 =  87   ;   ij1 =  88
-               ii0 = 161   ;   ii1 = 163
-               DO jl = mi0(il0), mi1(il1)
-                  DO jj = mj0(ij0), mj1(ij1)
-                     DO ji = mi0(ii0), mi1(ii1)
-#if defined key_orca_lev10
-                        ztem  (ji,jj,:,:) = ztem  (jl,jj,:,:)
-#else
-                        temdta(ji,jj,:,:) = temdta(jl,jj,:,:)
-#endif
-                     END DO
-                  END DO
-               END DO
-               !
-            ELSE
-               !                                         ! Reduced temperature at Red Sea
-               ij0 =  87   ;   ij1 =  96
-               ii0 = 148   ;   ii1 = 160
-#if defined key_orca_lev10
-               ztem  ( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ,  4:10 , : ) = 7.0 
-               ztem  ( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , 11:13 , : ) = 6.5 
-               ztem  ( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , 14:20 , : ) = 6.0
-#else
-               temdta( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ,  4:10 , : ) = 7.0 
-               temdta( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , 11:13 , : ) = 6.5 
-               temdta( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , 14:20 , : ) = 6.0
-#endif
-            ENDIF
-            !
-         ENDIF
-#endif
-         
-#if defined key_orca_lev10
-         ! interpolate from 31 to 301 level the ztem field result in temdta
-         DO jl = 1, 2
-            DO jjk = 1, 5
-               temdta(:,:,jjk,jl) = ztem(:,:,1,jl)
-            END DO
-            DO jk = 1, jpk-20,10
-               ik = jk+5
-               ikr =  INT(jk/10) + 1
-               ikw =  (ikr-1) *10 + 1
-               ikt =  ikw + 5
-               DO jjk=ikt,ikt+9
-                  zfac = ( gdept_0(jjk   ) - gdepw_0(ikt) ) / ( gdepw_0(ikt+10) - gdepw_0(ikt) )
-                  temdta(:,:,jjk,jl) = ztem(:,:,ikr,jl) + ( ztem(:,:,ikr+1,jl) - ztem(:,:,ikr,jl) ) * zfac
-               END DO
-            END DO
-            DO jjk = jpk-5, jpk
-               temdta(:,:,jjk,jl) = ztem(:,:,jpkdta-1,jl)
-            END DO
-            ! fill the overlap areas
-            CALL lbc_lnk (temdta(:,:,:,jl),'Z',-999.,'no0')
-         END DO
-#endif
-         
-         IF( ln_sco ) THEN
-            DO jl = 1, 2
-               DO jj = 1, jpj                  ! interpolation of temperatures
-                  DO ji = 1, jpi
-                     DO jk = 1, jpk
-                        zl=fsdept_0(ji,jj,jk)
-                        IF(zl < gdept_0(1)) ztemdta(jk,jl) =  temdta(ji,jj,1,jl)
-                        IF(zl > gdept_0(jpk)) ztemdta(jk,jl) =  temdta(ji,jj,jpkm1,jl)
-                        DO jkk = 1, jpkm1
-                           IF((zl-gdept_0(jkk))*(zl-gdept_0(jkk+1)).le.0.0) THEN
-                              ztemdta(jk,jl) = temdta(ji,jj,jkk,jl)                                 &
-                                   &           + (zl-gdept_0(jkk))/(gdept_0(jkk+1)-gdept_0(jkk))      &
-                                   &                              *(temdta(ji,jj,jkk+1,jl) - temdta(ji,jj,jkk,jl))
-                           ENDIF
-                        END DO
-                     END DO
-                     DO jk = 1, jpkm1
-                        temdta(ji,jj,jk,jl) = ztemdta(jk,jl)
-                     END DO
-                     temdta(ji,jj,jpk,jl) = 0.0
-                  END DO
-               END DO
-            END DO
-            
-            IF(lwp) WRITE(numout,*)
-            IF(lwp) WRITE(numout,*) ' Levitus temperature data interpolated to s-coordinate'
-            IF(lwp) WRITE(numout,*)
-            
-         ELSE
-            
-            !                                  ! Mask
-            DO jl = 1, 2
-               temdta(:,:,:,jl) = temdta(:,:,:,jl) * tmask(:,:,:)
-               temdta(:,:,jpk,jl) = 0.
-               IF( ln_zps ) THEN                ! z-coord. with partial steps
-                  DO jj = 1, jpj                  ! interpolation of temperature at the last level
-                     DO ji = 1, jpi
-                        ik = mbathy(ji,jj) - 1
-                        IF( ik > 2 ) THEN
-                           zl = ( gdept_0(ik) - fsdept_0(ji,jj,ik) ) / ( gdept_0(ik) - gdept_0(ik-1) )
-                           temdta(ji,jj,ik,jl) = (1.-zl) * temdta(ji,jj,ik,jl) + zl * temdta(ji,jj,ik-1,jl)
-                        ENDIF
-                     END DO
-                  END DO
-               ENDIF
-            END DO
-            
-         ENDIF
-         
-         IF(lwp) THEN
-            WRITE(numout,*) ' temperature Levitus month ', ntem1, ntem2
-            WRITE(numout,*)
-            WRITE(numout,*) ' Levitus month = ', ntem1, '  level = 1'
-            CALL prihre( temdta(:,:,1,1), jpi, jpj, 1, jpi, 20, 1, jpj, 20, 1., numout )
-            WRITE(numout,*) ' Levitus month = ', ntem1, '  level = ', jpk/2
-            CALL prihre( temdta(:,:,jpk/2,1), jpi, jpj, 1, jpi, 20, 1, jpj, 20, 1., numout )
-            WRITE(numout,*) ' Levitus month = ',ntem1,'  level = ', jpkm1
-            CALL prihre( temdta(:,:,jpkm1,1), jpi, jpj, 1, jpi, 20, 1, jpj, 20, 1., numout )
-         ENDIF
-      ENDIF
-      
-      
-      ! 2. At every time step compute temperature data
-      ! ----------------------------------------------
-      
-      zxy = FLOAT( nday + 15 - 30 * i15 ) / 30.
-      t_dta(:,:,:) = (1.-zxy) * temdta(:,:,:,1) + zxy * temdta(:,:,:,2)
-      
-      ! Close the file
-      ! --------------
-      
-      IF( kt == nitend )   CALL iom_close (numtdt)
-      
-    END SUBROUTINE dta_tem
+      ELSE
+         !                                  ! Mask
+         t_dta(:,:,:  ) = t_dta(:,:,:) * tmask(:,:,:)
+         t_dta(:,:,jpk) = 0.
+         IF( ln_zps ) THEN                ! z-coord. with partial steps
+            DO jj = 1, jpj                ! interpolation of temperature at the last level
+               DO ji = 1, jpi
+                  ik = mbkt(ji,jj)
+                  IF( ik > 1 ) THEN
+                     zl = ( gdept_0(ik) - fsdept_0(ji,jj,ik) ) / ( gdept_0(ik) - gdept_0(ik-1) )
+                     t_dta(ji,jj,ik) = (1.-zl) * t_dta(ji,jj,ik) + zl * t_dta(ji,jj,ik-1)
+                  ENDIF
+               END DO
+            END DO
+         ENDIF
+         !
+      ENDIF
+         
+      IF( lwp .AND. kt == nit000 ) THEN
+         WRITE(numout,*) ' temperature Levitus '
+         WRITE(numout,*)
+         WRITE(numout,*)'  level = 1'
+         CALL prihre( t_dta(:,:,1    ), jpi, jpj, 1, jpi, 20, 1, jpj, 20, 1., numout )
+         WRITE(numout,*)'  level = ', jpk/2
+         CALL prihre( t_dta(:,:,jpk/2), jpi, jpj, 1, jpi, 20, 1, jpj, 20, 1., numout )
+         WRITE(numout,*)'  level = ', jpkm1
+         CALL prihre( t_dta(:,:,jpkm1), jpi, jpj, 1, jpi, 20, 1, jpj, 20, 1., numout )
+      ENDIF
+      !
+   END SUBROUTINE dta_tem
 
 #else
